#include <cassert>
#include <cstring>
#include <string>
#include <iostream>
#include <ostream>
using namespace std;

#include "util.h"

#define NOF_RUN  1000000

int main()
{
    fixed_string fs1;
    fixed_string fs2;
    int fscmp[NOF_RUN];

    std::string ss1;
    std::string ss2;
    int sscmp[NOF_RUN];

    const char * s;

    s = gen_str();
    strcpy(fs1, s);
    ss1 = s;

    s = gen_str();
    strcpy(fs2, s);
    ss2 = s;

    /* C strcmp */
    auto fst1 = get_time();
    for (size_t i = 0; i < NOF_RUN; ++i) {
        fscmp[i] = strcmp(fs1, fs2);
    }
    auto fst2 = get_time();
    cout << "fixed_string: " << time_diff(fst1, fst2).count() << endl;

    /* C++ string::compare */
    auto sst1 = get_time();
    for (size_t i = 0; i < NOF_RUN; ++i) {
        sscmp[i] = ss1.compare(ss2);
    }
    auto sst2 = get_time();
    cout << "std::string : " << time_diff(sst1, sst2).count() << endl;

    for (size_t i = 0; i < NOF_RUN; ++i) {
        assert(fscmp[i] == sscmp[i]);
    }

}
